<?
include_once('variables.inc.php');

function validate($uploaded_file, $valid_extensions)
{
	if($uploaded_file['error'] != UPLOAD_ERR_OK || !is_uploaded_file($uploaded_file['tmp_name']))
	{
	   return('');
	}                               
	
	foreach($valid_extensions as $valid_extension)
	{
			if(strripos($uploaded_file['name'], '.' . $valid_extension) == strlen($uploaded_file['name']) - strlen($valid_extension) - 1)
			{
			   return('.' . $valid_extension);
			}
	}
	
	return('');
}

function numberOfFiles($valid_extensions) {
	$pattern = 'images/*.{' . implode(',', $valid_extensions) . '}';
	return(count(glob($pattern, GLOB_BRACE)));
}

function format($string) {
	$string = htmlentities($string); 
	$string = trim($string);
	$string = str_replace(' ', '-', $string);
	return($string);
}

function getImageResource($uploadedFile, $extension) {
	switch($extension) {
		case '.png':
			return(imageCreateFromPNG($uploadedFile));
			break;
		case '.jpg':
			return(imageCreateFromJPEG($uploadedFile));
			break;
		case '.gif':
			return(imageCreateFromGIF($uploadedFile));
			break;
	}
	
	return(null);
}

$fileCount = numberOfFiles($valid_extensions);

$submitted_user = $_POST['user'];
$submitted_password = $_POST['password'];

$topic = $_POST['topic'];
$title = $_POST['title'];

$extension = validate( $_FILES['file'], $valid_extensions);
$prefix = sprintf('%04d', $fileCount);

if($extension != '' && $submitted_user == $user && $submitted_password == $password) {
	setcookie('user', $submitted_user);
	setcookie('password', $submitted_password);
	
	$uploadedFile = $_FILES['file']['tmp_name'];
	
	$imageSize = getImageSize($uploadedFile);
	$imageWidth = $imageSize[0];
	$imageHeight = $imageSize[1];
	
	$image = getImageResource($uploadedFile, $extension);
	
	$thumbnail = imageCreateTrueColor($thumbnailWidth, $thumbnailHeight);
	
	imageCopy($thumbnail, $image, 0, 0, ($imageWidth - $thumbnailWidth) / 2, ($imageHeight - $thumbnailHeight) / 2, $thumbnailWidth, $thumbnailHeight);
	
	$file_name = $prefix . '.' . format($topic) . '.' . format($title) . $extension;
	
	if(!file_exists('./images')) {
		mkdir('./images', 0777, true);
	}
	
	if(!file_exists('./thumbs')) {
		mkdir('./thumbs', 0777, true);
	}
	
	imagepng($thumbnail, './thumbs/thumb.' .  $file_name);

	move_uploaded_file($uploadedFile, './images/' . $file_name);
	
	include('build.php');
}
?>
location.reload();
